package service.impl;

import commons.JdbcUtils;
import projo.Users;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class UserManagerDaoImpl implements UserManagerDao  {
    //添加用户
    @Override
    public void insertUser(Users users) {
        Connection connection=null;
        try{
            connection= JdbcUtils.getConnection();
            connection.setAutoCommit(false);
            PreparedStatement ps=connection.prepareStatement("insert into users values(default ,?,?,?,?,?)");
            ps.setString(1,users.getUsername());
            ps.setString(2,users.getUserpwd());
            ps.setString(3,users.getUsersex());
            ps.setString(4,users.getPhonenumber());
            ps.setString(5,users.getQqnumber());
            ps.execute();
            connection.commit();
        } catch (SQLException e) {
            e.printStackTrace();
            JdbcUtils.rollbackConnection(connection);
        }
        finally {
            JdbcUtils.closeConnection(connection);
        }
    }
//查询用户
    @Override
    public List<Users> selectUserByProperty(Users users) {
        Connection connection=null;
        List<Users> list=new ArrayList<>();
        try{
            connection=JdbcUtils.getConnection();
            String sql=this.createSql(users);
            PreparedStatement preparedStatement=connection.prepareStatement(sql);
            ResultSet resultSet=preparedStatement.executeQuery();
            while (resultSet.next()){
                Users user=new Users();
                user.setUserid(resultSet.getInt("userid"));
                user.setPhonenumber(resultSet.getString("phonenumber"));
                user.setQqnumber(resultSet.getString("qqnumber"));
                user.setUserpwd(resultSet.getString("userpwd"));
                user.setUsername(resultSet.getString("username"));
                user.setUsersex(resultSet.getString("usersex"));
                list.add(user);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        finally {
            JdbcUtils.closeConnection(connection);
        }
        return list;
    }
    private String createSql(Users users){
        StringBuffer stringBuffer=new StringBuffer("select * from users where 1=1");
        if(users.getUsersex()!=null&&users.getUsersex().length()>0){
            stringBuffer.append("and usersex='"+users.getUsersex()+"'");
        }
        if(users.getQqnumber()!=null&&users.getQqnumber().length()>0){
            stringBuffer.append("and qqnumber='"+users.getQqnumber()+"'");
        }
        if(users.getUsername()!=null&&users.getUsername().length()>0){
            stringBuffer.append("and username='"+users.getUsername()+"'");
        }
        if(users.getPhonenumber()!=null&&users.getPhonenumber().length()>0){
            stringBuffer.append("and phonenumber='"+users.getPhonenumber()+"'");
        }
        return stringBuffer.toString();
    }
}
