package web.servlet;

import commons.Constants;
import exception.UserNotFoundException;
import projo.Users;
import service.impl.UserLoginService;
import service.impl.UserLoginServiceImpl;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;

//处理用户登陆请求
@WebServlet("/login.do")
public class UserLoginServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req,resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        //获取post/get传递的值
        String username=req.getParameter("username");
        String userpwd=req.getParameter("userpwd");
        String code=req.getParameter("code");
        try {
            HttpSession session=req.getSession();
            String codeTemp=(String)session.getAttribute(Constants.Validate_Code_Key);
            if (codeTemp.equals(code)){
                UserLoginService userLoginService=new UserLoginServiceImpl();
                Users users=userLoginService.userLogin(username,userpwd);
                //建立客户端与服务端的会话连接

                session.setAttribute(Constants.User_Session_Key,users);
                ServletContext servletContext=this.getServletContext();
                HttpSession temp=(HttpSession)servletContext.getAttribute(users.getUserid()+"");
                if (temp!=null){
                    servletContext.removeAttribute(users.getUserid()+"");
                    temp.invalidate();
                }
                servletContext.setAttribute(users.getUserid()+"",session);
                //重定向
                resp.sendRedirect("main.jsp");
            }else {
                req.setAttribute(Constants.Rqeuest_Msg,"验证码有误，请重新输入");
                req.getRequestDispatcher("login.jsp").forward(req,resp);
            }


        }
        catch (UserNotFoundException e){
            req.setAttribute("msg",e.getMessage());
            //请求转发（forward），请求包含：include
            req.getRequestDispatcher("login.jsp").forward(req,resp);

        }
        catch (Exception e){
            resp.sendRedirect("error.jsp");
        }
    }
}
